function step7_define_biased_unbiased_peaks(peak_name_1, peak_name_2, workdir, MAtype, outputdir, Mcut_unbiased, Mcut_biased, Pcut_biased)
%MAtype = MApair

clear peak peak1common peak1unique;
commonpeakfile1 = [workdir, peak_name_1, '_common_peaks_', MAtype, '_MAvalue.mat'];
load(commonpeakfile1);         % peak
peak1common = peak;

uniquepeakfile1 = [workdir, peak_name_1, '_unique_peaks_', MAtype, '_MAvalue.mat'];
load(uniquepeakfile1);         % peak
peak1unique = peak;

clear peak peak2common peak2unique;
commonpeakfile2 = [workdir, peak_name_2, '_common_peaks_', MAtype, '_MAvalue.mat'];
load(commonpeakfile2);         % peak
peak2common = peak;

uniquepeakfile2 = [workdir, peak_name_2, '_unique_peaks_', MAtype, '_MAvalue.mat'];
load(uniquepeakfile2);         % peak
peak2unique = peak;

% define sample 1 biased peaks from peaks
disp(['Define sample 1 biased peaks from ', peak_name_1, ' peaks:']);
Isel1common = find(peak1common.Mvalue_rescaled>=Mcut_biased & peak1common.pvalue_MAvalue<Pcut_biased);
n1common = length(Isel1common);
disp([num2str(n1common), ' peaks with Fold Change>=', num2str(2^Mcut_biased), ' are filtered from ', peak_name_1, ' common peaks']); 

clear peak;
peak.chr_id = peak1common.chr_id(Isel1common);
peak.bpstart = peak1common.bpstart(Isel1common);
peak.bpend = peak1common.bpend(Isel1common);
peak.bpsummit = peak1common.bpsummit(Isel1common);
peak.Mvalue_rescaled = peak1common.Mvalue_rescaled(Isel1common);
peak.Avalue_rescaled = peak1common.Avalue_rescaled(Isel1common);
peak.pvalue_MAvalue = peak1common.pvalue_MAvalue(Isel1common);
save([workdir, peak_name_1, '_common_M', num2str(Mcut_biased), 'higher_bound_region.mat'], 'peak');

fbed1 = fopen([outputdir, peak_name_1, '_biased_M', num2str(Mcut_biased), 'higher_peaks.bed'], 'w');
for kk = 1:n1common
    fprintf(fbed1, '%s\t%d\t%d\tFrom_%s_common_peaks\t%f\n', peak.chr_id{kk}, peak.bpstart(kk), peak.bpend(kk), peak_name_1, peak.Mvalue_rescaled(kk));
end

Isel1unique = find(peak1unique.Mvalue_rescaled>=Mcut_biased & peak1unique.pvalue_MAvalue<Pcut_biased);
n1unique = length(Isel1unique);
disp([num2str(n1unique), ' peaks with Fold Change>=', num2str(2^Mcut_biased), ' are filtered from ', peak_name_1, ' unique peaks']); 

clear peak;
peak.chr_id = peak1unique.chr_id(Isel1unique);
peak.bpstart = peak1unique.bpstart(Isel1unique);
peak.bpend = peak1unique.bpend(Isel1unique);
peak.bpsummit = peak1unique.bpsummit(Isel1unique);
peak.Mvalue_rescaled = peak1unique.Mvalue_rescaled(Isel1unique);
peak.Avalue_rescaled = peak1unique.Avalue_rescaled(Isel1unique);
peak.pvalue_MAvalue = peak1unique.pvalue_MAvalue(Isel1unique);
save([workdir, peak_name_1, '_unique_M', num2str(Mcut_biased), 'higher_bound_region.mat'], 'peak');

disp(['In total, ', num2str(n1common+n1unique), ' peaks with Fold Change>=', num2str(2^Mcut_biased), ' are filtered from ', peak_name_1, ' peaks']); 
for kk = 1:n1unique
    fprintf(fbed1, '%s\t%d\t%d\tFrom_%s_unique_peaks\t%f\n', peak.chr_id{kk}, peak.bpstart(kk), peak.bpend(kk), peak_name_1, peak.Mvalue_rescaled(kk));
end
fclose(fbed1);


% define sample 2 biased peaks
disp(['Define sample 2 biased peaks from ', peak_name_2, ' peaks:']);
Isel2common = find(peak2common.Mvalue_rescaled<=-Mcut_biased & peak2common.pvalue_MAvalue<Pcut_biased);
n2common = length(Isel2common);
disp([num2str(n2common), ' peaks with Fold Change<=-', num2str(2^Mcut_biased), ' are filtered from ', peak_name_2, ' common peaks']); 

clear peak;
peak.chr_id = peak2common.chr_id(Isel2common);
peak.bpstart = peak2common.bpstart(Isel2common);
peak.bpend = peak2common.bpend(Isel2common);
peak.bpsummit = peak2common.bpsummit(Isel2common);
peak.Mvalue_rescaled = peak2common.Mvalue_rescaled(Isel2common);
peak.Avalue_rescaled = peak2common.Avalue_rescaled(Isel2common);
peak.pvalue_MAvalue = peak2common.pvalue_MAvalue(Isel2common);
save([workdir, peak_name_2, '_common_M-', num2str(Mcut_biased), 'lower_bound_region.mat'], 'peak');

fbed2 = fopen([outputdir, peak_name_2, '_biased_M-', num2str(Mcut_biased), 'lower_peaks.bed'], 'w');
for kk = 1:n2common
    fprintf(fbed2, '%s\t%d\t%d\tFrom_%s_common_peaks\t%f\n', peak.chr_id{kk}, peak.bpstart(kk), peak.bpend(kk), peak_name_2, peak.Mvalue_rescaled(kk));
end

Isel2unique = find(peak2unique.Mvalue_rescaled<=-Mcut_biased & peak2unique.pvalue_MAvalue<Pcut_biased);
n2unique = length(Isel2unique);
disp([num2str(n2unique), ' peaks with Fold Change<=-', num2str(2^Mcut_biased), ' are filtered from ', peak_name_2, ' unique peaks']); 

clear peak;
peak.chr_id = peak2unique.chr_id(Isel2unique);
peak.bpstart = peak2unique.bpstart(Isel2unique);
peak.bpend = peak2unique.bpend(Isel2unique);
peak.bpsummit = peak2unique.bpsummit(Isel2unique);
peak.Mvalue_rescaled = peak2unique.Mvalue_rescaled(Isel2unique);
peak.Avalue_rescaled = peak2unique.Avalue_rescaled(Isel2unique);
peak.pvalue_MAvalue = peak2unique.pvalue_MAvalue(Isel2unique);
save([workdir, peak_name_2, '_unique_M-', num2str(Mcut_biased), 'lower_bound_region.mat'], 'peak');

disp(['In total, ', num2str(n2common+n2unique), ' peaks with Fold Change<=-', num2str(2^Mcut_biased), ' are filtered from ', peak_name_2, ' peaks']); 
for kk = 1:n2unique
    fprintf(fbed2, '%s\t%d\t%d\tFrom_%s_unique_peaks\t%f\n', peak.chr_id{kk}, peak.bpstart(kk), peak.bpend(kk), peak_name_2, peak.Mvalue_rescaled(kk));
end
fclose(fbed2);


% define sample 1 and 2 unbiased peaks
disp(['Define sample 1 and 2 unbiased peaks from ', peak_name_1, ' and ', peak_name_2, ' peaks:']);

% first merge overlapping common peaks
clear peak;
peak.chr_id = [peak1common.chr_id; peak2common.chr_id];
peak.bpstart = [peak1common.bpstart; peak2common.bpstart];
peak.bpend = [peak1common.bpend; peak2common.bpend];
peak.bpsummit = [peak1common.bpsummit; peak2common.bpsummit];
peak.Mvalue_rescaled = [peak1common.Mvalue_rescaled; peak2common.Mvalue_rescaled];
peak.Avalue_rescaled = [peak1common.Avalue_rescaled; peak2common.Avalue_rescaled];
peak.pvalue_MAvalue = [peak1common.pvalue_MAvalue; peak2common.pvalue_MAvalue];

npeak = length(peak.chr_id);
chr_id_str = unique(peak.chr_id);

peak_response = ones(npeak, 1);          % whetehr the peaks will be retained or merged
peak_number = ones(npeak, 1);          % whetehr the peaks will be retained or merged
peak_max_Mvalue = peak.Mvalue_rescaled;          % whetehr the peaks will be retained or merged
for i = 1:length(chr_id_str)
    Ichr = find(strcmp(peak.chr_id, chr_id_str{i}));
    [bpstart_sort, Isort] = sort(peak.bpstart(Ichr), 'ascend');
            
    kk = 1;
    while kk < length(Ichr)
        cnt = 1;
        for mm = kk+1:length(Ichr)
            Iref = Ichr(Isort(kk));
            Icom = Ichr(Isort(mm));
            
            if peak.bpstart(Icom)<=peak.bpend(Iref)
                cnt = cnt + 1;
                peak.bpend(Iref) = max(peak.bpend(Iref), peak.bpend(Icom));
                peak.bpsummit(Iref) = peak.bpsummit(Iref) + peak.bpsummit(Icom);
                peak.Mvalue_rescaled(Iref) = peak.Mvalue_rescaled(Iref) + peak.Mvalue_rescaled(Icom);
                peak.Avalue_rescaled(Iref) = peak.Avalue_rescaled(Iref) + peak.Avalue_rescaled(Icom);
                peak.pvalue_MAvalue(Iref) = max(peak.pvalue_MAvalue(Iref), peak.pvalue_MAvalue(Icom));
                if abs(peak_max_Mvalue(Iref))<abs(peak_max_Mvalue(Icom))
                    peak_max_Mvalue(Iref) = peak_max_Mvalue(Icom);
                end
                peak_number(Iref) = peak_number(Iref) + 1;
                peak_response(Icom) = 0;
            else
                kk = mm;
                break;
            end
        end
        
        if mm == length(Ichr)
            kk = length(Ichr);
        end
    end
end
peak.bpsummit = peak.bpsummit./peak_number;
peak.Mvalue_rescaled = peak.Mvalue_rescaled./peak_number;
peak.Avalue_rescaled = peak.Avalue_rescaled./peak_number;

% extact unbiased common peaks
I12common = find(peak_response & abs(peak_max_Mvalue)<Mcut_unbiased);
n12common = length(I12common);
disp([num2str(n12common), ' peaks with |Fold Change|<', num2str(2^Mcut_unbiased), ' are filtered from merged ', peak_name_1, ' and ', peak_name_2, ' common peaks']); 

clear peak0;
peak0.chr_id = peak.chr_id(I12common);
peak0.bpstart = peak.bpstart(I12common);
peak0.bpend = peak.bpend(I12common);
peak0.bpsummit = peak.bpsummit(I12common);
peak0.Mvalue_rescaled = peak.Mvalue_rescaled(I12common);
peak0.Avalue_rescaled = peak.Avalue_rescaled(I12common);
peak0.pvalue_MAvalue = peak.pvalue_MAvalue(I12common);
peak = peak0;
save([workdir, peak_name_1, '_and_', peak_name_2, '_common_absM', num2str(Mcut_unbiased), 'lower_bound_region.mat'], 'peak');

fbed = fopen([outputdir, peak_name_1, '_and_', peak_name_2, '_unbiased_absM', num2str(Mcut_unbiased), 'lower_peaks.bed'], 'w');
for kk = 1:n12common
    fprintf(fbed, '%s\t%d\t%d\tFrom_merged_%s_and_%s_common_peaks\t%f\n', peak.chr_id{kk}, peak.bpstart(kk), peak.bpend(kk), peak_name_1, peak_name_2, peak.Mvalue_rescaled(kk));
end

% extact unbiased sample 1 unique peaks
Isel1unique = find(abs(peak1unique.Mvalue_rescaled)<Mcut_unbiased);
n1unique = length(Isel1unique);
disp([num2str(n1unique), ' peaks with |Fold Change|<', num2str(2^Mcut_unbiased), ' are filtered from ', peak_name_1, ' unique peaks']); 

clear peak;
peak.chr_id = peak1unique.chr_id(Isel1unique);
peak.bpstart = peak1unique.bpstart(Isel1unique);
peak.bpend = peak1unique.bpend(Isel1unique);
peak.bpsummit = peak1unique.bpsummit(Isel1unique);
peak.Mvalue_rescaled = peak1unique.Mvalue_rescaled(Isel1unique);
peak.Avalue_rescaled = peak1unique.Avalue_rescaled(Isel1unique);
peak.pvalue_MAvalue = peak1unique.pvalue_MAvalue(Isel1unique);
save([workdir, peak_name_1, '_unique_absM', num2str(Mcut_unbiased), 'lower_bound_region.mat'], 'peak');

for kk = 1:n1unique
    fprintf(fbed, '%s\t%d\t%d\tFrom_%s_unique_peaks\t%f\n', peak.chr_id{kk}, peak.bpstart(kk), peak.bpend(kk), peak_name_1, peak.Mvalue_rescaled(kk));
end

% extact unbiased sample 2 unique peaks
Isel2unique = find(abs(peak2unique.Mvalue_rescaled)<Mcut_unbiased);
n2unique = length(Isel2unique);
disp([num2str(n2unique), ' peaks with |Fold Change|<', num2str(2^Mcut_unbiased), ' are filtered from ', peak_name_2, ' unique peaks']); 

clear peak;
peak.chr_id = peak2unique.chr_id(Isel2unique);
peak.bpstart = peak2unique.bpstart(Isel2unique);
peak.bpend = peak2unique.bpend(Isel2unique);
peak.bpsummit = peak2unique.bpsummit(Isel2unique);
peak.Mvalue_rescaled = peak2unique.Mvalue_rescaled(Isel2unique);
peak.Avalue_rescaled = peak2unique.Avalue_rescaled(Isel2unique);
peak.pvalue_MAvalue = peak2unique.pvalue_MAvalue(Isel2unique);
save([workdir, peak_name_2, '_unique_absM', num2str(Mcut_unbiased), 'lower_bound_region.mat'], 'peak');

for kk = 1:n2unique
    fprintf(fbed, '%s\t%d\t%d\tFrom_%s_unique_peaks\t%f\n', peak.chr_id{kk}, peak.bpstart(kk), peak.bpend(kk), peak_name_2, peak.Mvalue_rescaled(kk));
end
fclose(fbed);

disp(['In total, ', num2str(n12common+n1unique+n2unique), ' peaks with |Fold Change|<', num2str(2^Mcut_unbiased), ' are filtered from ', peak_name_1, ' and ', peak_name_2, ' peaks']); 
